# All files / src/node-transformers/node-obfuscators VariableDeclarationObfuscator.ts

100% Statements 28/28
100% Branches 8/8
100% Functions 3/3
100% Lines 25/25

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    991x
    1x

    1x

    1x
    1x

    1x
    1x
    1x
    1x

    1x

    1804x

    1804x

    15083x

    15083x
    570x

    14513x
    14513x

    14513x
    14513x

    14513x

    17582x
    17582x

    14513x

    1908805x
    470807x

     import { injectable, inject } from 'inversify';
    import { ServiceIdentifiers } from '../../container/ServiceIdentifiers';

    import * as estraverse from 'estraverse';
    import * as ESTree from 'estree';

    import { TNodeWithBlockStatement } from '../../types/node/TNodeWithBlockStatement';

    import { IOptions } from '../../interfaces/options/IOptions';
    import { IObfuscatorReplacer } from '../../interfaces/node-transformers/IObfuscatorReplacer';
    import { IObfuscatorReplacerWithStorage } from '../../interfaces/node-transformers/IObfuscatorReplacerWithStorage';

    import { NodeObfuscatorsReplacers } from '../../enums/container/NodeObfuscatorsReplacers';
    import { NodeType } from '../../enums/NodeType';

    import { AbstractNodeTransformer } from '../AbstractNodeTransformer';
    import { Node } from '../../node/Node';
    import { NodeUtils } from '../../node/NodeUtils';
    import { RandomGeneratorUtils } from '../../utils/RandomGeneratorUtils';

    /**
     * replaces:
     *     var variable = 1;
     *     variable++;
     *
     * on:
     *     var _0x12d45f = 1;
     *     _0x12d45f++;
     *
     */
    @injectable()
    export class VariableDeclarationObfuscator extends AbstractNodeTransformer {
        /**
         * @type {IObfuscatorReplacerWithStorage}
         */
        private readonly identifierReplacer: IObfuscatorReplacerWithStorage;

        /**
         * @param replacersFactory
         * @param options
         */
        constructor(
            @inject(ServiceIdentifiers['Factory<IObfuscatorReplacer>']) replacersFactory: (replacer: NodeObfuscatorsReplacers) => IObfuscatorReplacer,
            @inject(ServiceIdentifiers.IOptions) options: IOptions
        ) {
            super(options);

            this.identifierReplacer = <IObfuscatorReplacerWithStorage>replacersFactory(NodeObfuscatorsReplacers.IdentifierReplacer);
        }

        /**
         * @param variableDeclarationNode
         * @param parentNode
         */
        public transformNode (variableDeclarationNode: ESTree.VariableDeclaration, parentNode: ESTree.Node): void {
            const blockScopeOfVariableDeclarationNode: TNodeWithBlockStatement = NodeUtils
                .getBlockScopesOfNode(variableDeclarationNode)[0];

            if (blockScopeOfVariableDeclarationNode.type === NodeType.Program) {
                return;
            }

            const nodeIdentifier: string = RandomGeneratorUtils.getRandomString(7);
            const scopeNode: ESTree.Node = variableDeclarationNode.kind === 'var'
                ? blockScopeOfVariableDeclarationNode
                : parentNode;

            this.storeVariableNames(variableDeclarationNode, nodeIdentifier);
            this.replaceVariableNames(scopeNode, nodeIdentifier);
        }

        /**
         * @param variableDeclarationNode
         * @param nodeIdentifier
         */
        private storeVariableNames (variableDeclarationNode: ESTree.VariableDeclaration, nodeIdentifier: string): void {
            variableDeclarationNode.declarations
                .forEach((declarationNode: ESTree.VariableDeclarator) => {
                    NodeUtils.typedTraverse(declarationNode.id, NodeType.Identifier, {
                        enter: (node: ESTree.Identifier) => this.identifierReplacer.storeNames(node.name, nodeIdentifier)
                    });
                });
        }

        /**
         * @param scopeNode
         * @param nodeIdentifier
         */
        private replaceVariableNames (scopeNode: ESTree.Node, nodeIdentifier: string): void {
            estraverse.replace(scopeNode, {
                enter: (node: ESTree.Node, parentNode: ESTree.Node): any => {
                    if (!node.obfuscated && Node.isReplaceableIdentifierNode(node, parentNode)) {
                        node.name = this.identifierReplacer.replace(node.name, nodeIdentifier);
                    }
                }
            });
        }
    }